/*
 * Proyecto:      Propsito general
 * Fichero:       Llamadas.prg
 * Descripcin:   Llamadas desde el programa via Tonos o SKYPE
 * Autor:         Bingen Ugaldebere
 * Fecha:         02/03/2008
 */

// Para pruebas de los comandos de la centralita       http://mundosms.es/APIv2/client_soap.php

#include "Xailer.ch"


#define HKEY_LOCAL_MACHINE 0x80000002

CLASS TLlamadas FROM TForm

   Data cPrefijo        Init ""
   Data aTelefonos      Init {}

   DATA lInstalled      INIT .F.
   Data cInstalledPath  Init ""

//   Data cMundoSMSUser      Init Appdata:cMundoSMSUser
//   Data cMundoSMSPassword  Init Appdata:cMundoSMSPassword

   COMPONENT oOcx
   COMPONENT oBevel1
   COMPONENT oBrwTelefonos
   COMPONENT oBevelBtn
   COMPONENT oBtnLlamar
   COMPONENT oBtnSalir

   METHOD CreateForm()
   METHOD FormInitialize( oSender )
   METHOD BtnTelefonoClick( oSender )
   METHOD BrwTelefonosKeyDown( oSender, nKey, nFlags )

ENDCLASS

#include "Llamadas.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TLlamadas

//   If !Appdata:Isdata("cMundoSMSUser")
//      Appdata:AddData("cMundoSMSUser",::cMundoSMSUser)
//   Endif
//   If !Appdata:Isdata("cMundoSMSPassword")
//      Appdata:AddData("cMundoSMSPassword",::cMundoSMSPassword)
//   Endif

//   IF (Empty(::cMundoSMSUser) .And. Empty(Appdata:cMundoSMSUser)) .Or. (Empty(::cMundoSMSPassword) .And. Empty(Appdata:cMundoSMSPassword))
//      MsgInfo("No hay datos de conexin a la centralita telefnica MundoSMS.")
//      ::oBtnHistorial:lEnabled:=.F.
//   Endif

   //Aadir lista al arraybrowse y ajustar anchuras
   ::oBrwTelefonos:aGridData        := ::aTelefonos
*   ::oBrwTelefonos:AdjustCols()

   //Si el browse es algo grande se cambian algunas cosas
*   If Len(::aTelefonos)>12
      ::nHeight:=Screen:nHeight*0.80                              //Se hace mas alta
      ::cText+="    ("+Tostring(Len(::aTelefonos))+" contactos)"  //Se aade al ttulo el nmero de elementos
      ::oBrwTelefonos:lFilterBar := .T.                           //Se muestra la barra de filtros
      ::oBrwTelefonos:oHeader:aControls[2]:SetFocus()             //Y nos situamos en el nombre para buscar
*   Endif

RETURN Nil

//------------------------------------------------------------------------------

METHOD BtnTelefonoClick( oSender ) CLASS TLlamadas

   Local cUrl:="", cJson := "" , cData := "" , hData
  msginfo(::oBrwTelefonos:oDataGrid:aDisplayCols[1]:Value+" "+::oBrwTelefonos:oDataGrid:aDisplayCols[2]:Value)
/*
   //Llamar desde una extensin determinada a un nmero de telfono de destino
   cUrl :=  "https://api.mundosms.es/APIv2/click2dial.php"
   cUrl +=  "?username="+GetConfiguracion("MundoSmsUser")+;
            "&password="+GetConfiguracion("MundoSmsPsw")+;
            "&extension="+AppData:oControlDb:QueryValue( "Select ExtensionVoIp from usuarios where usuario=" + ValToSql(Appdata:cUserName) )+;
            "&destination=+34"++;
            "&callerid_extension="+'"'+::oBrwTelefonos:oDataGrid:aDisplayCols[2]:Value+'" <'+::oBrwTelefonos:oDataGrid:aDisplayCols[1]:Value+'>'
   cUrl  := hb_strtoutf8( cUrl )

   WITH OBJECT TInternet():New()
      IF :Open()
         IF !Empty( hData := :OpenURL( cUrl ) )
            WHILE :ReadFile( hData, @cData, 65536 )
               cJson += cData
            ENDDO
            :CloseURL( hData )
         ENDIF
         :Close()
      ENDIF
   END
*/
RETURN NIL

//------------------------------------------------------------------------------

METHOD BrwTelefonosKeyDown( oSender, nKey, nFlags ) CLASS TLlamadas
   If nKey=13
      ::oBtnLlamar:Click()
   ElseIf nKey=27
      ::oBtnSalir:Click()
   Endif
   ::oBrwTelefonos:SetFocus(.T.)
RETURN Nil

//------------------------------------------------------------------------------
